diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/ass.p v15.6301-amd64/pop/src/ass.p
--- v15.63/pop/src/ass.p	1996-09-30 08:33:01.000000000 -0400
+++ v15.6301-amd64/pop/src/ass.p	2009-12-26 17:40:45.000000000 -0500
@@ -1598,6 +1828,9 @@
 		;;; Add -nresults- to saved stacklength in EAX; the _-6 accounts for
 		;;; the popint bits in the stacklength and nresults
 		Drop_imm(_ARITHI, _ADDI, _nresults _sub _6, (_REG, _EAX, false));
+        ;;; Adjust for the word size
+        Drop_std(_SHIFTI, _SAL, (_REG, _EAX, false)), Drop_b(_1);
+
 		;;; movl _userhi, %ecx
 		Drop_std(_MOV_IN, _ECX, (_ABS, _reg_ABS, ident _userhi));
 		;;; subl %eax, %ecx
@@ -1674,16 +1907,27 @@
 ;;;		input
 
 define Do_consprocedure(codelist, reg_locals) -> pdr;
-	lvars	codelist, reg_locals, pdr, _code_offset, _size, _reg_spec;
-	dlocal	_asm_drop_ptr, _asm_pass, _strsize;
-
+    lvars codelist, reg_locals, pdr, _code_offset, _size, _reg_spec;
+    lvars reg, _buff, _cnt;
+    dlocal _regmask, _asm_drop_ptr, _asm_pass, _strsize;
 
+/*
 	;;; Check there are no register locals and set _reg_spec to 0
+;;;        _extern printf('Do_consprocedure, Pass 1\n');
+;;;        _extern fflush (_0);
 	unless null(reg_locals) then
 		mishap(reg_locals, 1, 'UNEXPECTED REGISTER LOCALS');
 	endunless;
+*/
 	_0 -> _reg_spec;
 
+        ;;; construct reg mask from reg_locals
+        _0 -> _regmask;
+        for reg in reg_locals do
+                _shift(_1, _int(Is_register(reg))) _biset _regmask -> _regmask
+        endfor;
+
+
 	;;; Pass 1 -- calculate instruction offsets
 	_0 ->> _USP_offset -> _strsize;
 	Code_pass(0, codelist) -> _code_offset;
@@ -1707,8 +1951,22 @@
 	@@PD_TABLE{_strsize _add _code_offset | b.r} _sub @@POPBASE -> _size;
 	Get_procedure(_size, _reg_spec) -> pdr;
 
+        _asm_drop_ptr -> _buff;
 	;;; Final pass -- plants the code
 	Code_pass(false, codelist) -> ;
+        _asm_drop_ptr _sub _buff -> _cnt;
+;;;
+;;;     Helper to show location of planted code (allow disassembling).
+;;;
+;;;        _extern printf('writing %ld bytes at 0x%lx for 0x%lx\n',
+;;;            _cnt, _buff, pdr) -> _ ;
+;;;        _extern fflush(_0) -> _ ;
+;;;
+;;;     Extra help: dump generated code to a file.
+;;;
+;;;        _extern write(_7, _buff, _cnt) -> _ ;
+;;;        _extern printf('wrote bytes\n') -> _ ;
+;;;        _extern fflush(_0) -> _ ;
 enddefine;
 
 endsection;		/* $-Sys$-Vm */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/closure_cons.p v15.6301-amd64/pop/src/closure_cons.p
--- v15.63/pop/src/closure_cons.p	1992-09-23 18:05:03.000000000 -0400
+++ v15.6301-amd64/pop/src/closure_cons.p	2005-03-11 05:30:39.000000000 -0500
@@ -17,7 +17,8 @@
 ;;; Macros for dropping code at -drop_ptr-
 
 lconstant macro (
-	LONG	= [_drop_ptr!(l)++ -> _drop_ptr],
+        QUAD    = [_drop_ptr!(l)++ -> _drop_ptr],
+	LONG	= [_drop_ptr!(i)++ -> _drop_ptr],
 	SHORT	= [_drop_ptr!(s)++ -> _drop_ptr],
 	BYTE	= [_drop_ptr!(b)++ -> _drop_ptr],
 );
@@ -31,11 +32,11 @@
 
 	;;; Compute size of closure code
 	if _zero(_nfroz) then
-		_5
+		_6
 	elseif _nfroz _gr _16 then
-		_12
+		_19
 	else
-		_nfroz _mult _6 _add _8
+		_nfroz _mult _8 _add _10
 	endif -> _size;
 	##(w)[_size | b.r] -> _size;
 
@@ -54,37 +55,46 @@
 	;;; On entry, closure address should be in ARG_REG_0 (EAX)
 	if _nfroz _gr _16 then
 		;;; Call via -Exec_closure-
-		;;; subl $4, %USP
-		_16:EB83 -> SHORT, _4 -> BYTE;						;;; 3 bytes
-		;;; movl %eax, (%USP)
-		_16:0389 -> SHORT;									;;; 2 bytes
+		;;; subq $8, %USP
+                _16:48 -> BYTE,
+		_16:EB83 -> SHORT, _8 -> BYTE;	;;; 4 bytes
+		;;; movq %eax, (%USP)
+                _16:48 -> BYTE,
+		_16:0389 -> SHORT;	;;; 3 bytes
 		;;; movl $[Exec_closure!PD_EXECUTE], %eax
-		_16:B8 -> BYTE, Exec_closure!PD_EXECUTE -> LONG;	;;; 5 bytes
+                _16:48 -> BYTE,
+		_16:B8 -> BYTE, 
+                Exec_closure!PD_EXECUTE -> QUAD;	;;; 10 bytes
 		;;; jmp *%eax
 		_16:E0FF -> SHORT;									;;; 2 bytes
 	else
 		;;; Push the frozen arguments and chain the pdpart
 		_0 -> _offs;
 		until _zero(_nfroz) do
-			;;; movl [@@PD_CLOS_FROZVALS{_offs}](%eax), %ecx
+			;;; movq [@@PD_CLOS_FROZVALS{_offs}](%rax), %rcx
 			;;; (the offset should be byte-sized)
-			_16:488B -> SHORT, @@PD_CLOS_FROZVALS{_offs} -> BYTE; ;;; 3 bytes
+                        _16:48 -> BYTE,
+			_16:488B -> SHORT, @@PD_CLOS_FROZVALS{_offs} -> BYTE;
+                                                         ;;; 4 bytes
 			@@(w){_offs}++ -> _offs;
-			;;; movl %ecx, [-offs](%USP)
-			_16:4B89 -> SHORT, _negate(_offs) -> BYTE;		;;; 3 bytes
+			;;; movq %rcx, [-offs](%USP)
+                        _16:48 -> BYTE,
+			_16:4B89 -> SHORT, _negate(_offs) -> BYTE;  ;;; 4 bytes
 			_nfroz _sub _1 -> _nfroz;
 		enduntil;
 		if _nonzero(_offs) then
 			;;; adjust the userstack pointer
-			;;; subl $[offs], %USP
-			_16:EB83 -> SHORT, _offs -> BYTE;				;;; 3 bytes
+			;;; subq $[offs], %USP
+                        _16:48 -> BYTE,
+			_16:EB83 -> SHORT, _offs -> BYTE;  ;;; 4 bytes
 		endif;
 		;;; now get PD_CLOS_PDPART address in ARG_REG_0
 		;;; movl [@@PD_CLOS_PDPART](%eax), %eax
-		_16:408B -> SHORT, @@PD_CLOS_PDPART -> BYTE;		;;; 3 bytes
+                _16:48 -> BYTE,
+		_16:408B -> SHORT, @@PD_CLOS_PDPART -> BYTE;	;;; 4 bytes
 		;;; and jump straight to its execute address
 		;;; (assuming @@PD_EXECUTE == 0)
-		;;; jmp *(%eax)
+		;;; jmp *(%rax)
 		_16:20FF -> SHORT;									;;; 2 bytes
 	endif;
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/control.p v15.6301-amd64/pop/src/control.p
--- v15.63/pop/src/control.p	1998-04-30 10:23:51.000000000 -0400
+++ v15.6301-amd64/pop/src/control.p	2005-03-11 05:30:39.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 1991. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:            C.all/src/control.p
  > Purpose:         Control procedures
  > Author:          John Gibson (see revisions)
@@ -266,10 +266,27 @@
 enddefine;
 
 define Set_call_stack_lim();
-	lvars	_safe = _sp()@(csword)-[Nframe_cslen(_2:1e7)],
+	lvars	_tmp, _safe = _sp()@(csword)-[Nframe_cslen(_2:1e7)],
 			_plim = _call_stack_hi@(csword)-[_pop_callstack_lim];
+	;;; if _pop_callstack_lim is large, the offset calculation can wrap
+	;;; round
+	if _plim >@(csword) _call_stack_hi then
+		;;; choose some arbitrary limit close to the appropriate end of
+		;;; memory
+		_0@(csword)[_1|vpage] -> _plim;
+	endif;
+;;;        _extern
+;;;         printf('Set_call_stack_lim, _plim = %ld\n _pop_callstack_lim = %ld\n',
+;;;                  _plim, _pop_callstack_lim) -> _;
+;;;         _extern fflush(_0) -> _;
 	if _safe <@(csword) _plim then _safe -> _plim endif;
-	Trim_callstack_lim(_plim, false) -> _call_stack_lim
+;;;	Trim_callstack_lim(_plim, false) -> _call_stack_lim;
+        Trim_callstack_lim(_plim, false) -> _tmp;
+;;;        _extern
+;;;        printf('Set_call_stack_lim, _plim = %ld\n _callstack_lim = %ld\n',
+;;;                  _plim, _tmp) -> _;
+;;;        _extern fflush(_0) -> _;
+        _tmp -> _call_stack_lim;
 enddefine;
 
 	/*	Move the callstack area from _sp() to _limaddr up by _nwords
@@ -300,6 +317,10 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Robert Duncan, Jul 29 1999
+		Added a check in Set_call_stack_lim that calculation of the limit
+		doesn't wrap round. This can happen if the stack grows down in low
+		memory or up in high memory.
 --- John Gibson, Jan  3 1991
 		Made -Callstack_reset- check more stack frames
 --- John Gibson, Nov 15 1990
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/declare.ph v15.6301-amd64/pop/src/declare.ph
--- v15.63/pop/src/declare.ph	2003-11-01 16:15:27.000000000 -0500
+++ v15.6301-amd64/pop/src/declare.ph	2009-12-30 21:24:12.000000000 -0500
@@ -20,7 +20,8 @@
 		;;; system variables
 weak vars
 		_disable, _trap, _system_end, _userlim, _userhi,
-		_call_stack_hi, _call_stack_seg_hi, _plog_save_contn_sp
+		_call_stack_hi, _call_stack_seg_hi, _plog_save_contn_sp,
+                _user_base
 	;
 
 
@@ -40,6 +41,8 @@
 		undef_key, prologvar_key, prologterm_key,
 		intvec_key, shortvec_key, stackmark_key,
 		external_ptr_key, exptr_mem_key,
+                bytevec_key, sbytevec_key, ushortvec_key,
+                uintvec_key, ulongvec_key, longvec_key,
 
 	;
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/devio.p v15.6301-amd64/pop/src/devio.p
--- v15.63/pop/src/devio.p	1999-03-19 19:36:14.000000000 -0500
+++ v15.6301-amd64/pop/src/devio.p	2005-03-11 05:30:39.000000000 -0500
@@ -146,13 +146,15 @@
 	lvars _fd;
 #_IF DEF USE_TERMIOS
 	lstackmem struct TERMIOS _termios;
-	_nonneg(_extern tcgetattr(_fd, _termios));
+	_extern tcgetattr(_fd, _termios) _lteq _2147483647;
 #_ELSEIF DEF USE_TERMIO
 	lstackmem struct TERMIO _termio;
-	_nonneg(_extern[NI] ioctl(_fd, _TGETPARM, _termio))
+check this ;
+	_extern[NI] ioctl(_fd, _TGETPARM, _termio) _lteq _2147483647;
 #_ELSE
 	lstackmem struct SGTTYB _sgttyb;
-	_nonneg(_extern[NI] ioctl(_fd, _TGETPARM, _sgttyb))
+check this ;
+	_extern[NI] ioctl(_fd, _TGETPARM, _sgttyb) _lteq _2147483647;
 #_ENDIF
 enddefine;
 
@@ -219,7 +221,7 @@
 define Fix_dev_params(dev, _writing) -> devparams;
 	lvars	tcb = dev!D_CTRL_BLK, unit, devparams, ttyparams, dev,
 			_fd = dev!D_FILE_DESC, _writing;
-
+#_IF true
 #_IF DEF SIG_TTOU
 	;;; see if we are backgrounded (NB: we do this on all terminals,
 	;;; not just the controlling one - its easier and even non-controlling
@@ -242,7 +244,7 @@
 		endprocedure()
 	endunless;
 #_ENDIF
-
+#_ENDIF
 	;;; now in foreground -- test whether tty init params need (re)setting
 	dev!D_UNIT_P -> unit;
 	unit!UNT_INIT_TTPARAMS -> ttyparams;
@@ -1141,9 +1143,9 @@
 				exitto( (unit, dev!D_UNIT_P), Set_dev_unit)
 			endif
 		enddefine;
-
-		while _neg(_extern fstat(newdev!D_FILE_DESC, _statb))
-		and _ERRNO == _:EINTR do
+		while  (_extern fstat(newdev!D_FILE_DESC, _statb) 
+                _gr _2147483647
+		and _ERRNO == _:EINTR) do
 			_CHECKINTERRUPT
 		endwhile;
 		DEV_T_TO_VARS(_statb, ST_DEV, _udev, _udev2);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/discin.p v15.6301-amd64/pop/src/discin.p
--- v15.63/pop/src/discin.p	1996-03-15 11:17:41.000000000 -0500
+++ v15.6301-amd64/pop/src/discin.p	2005-03-11 05:30:39.000000000 -0500
@@ -23,6 +23,8 @@
 
 define discin(file) -> file;
 	lvars file, dev;
+;;;        _extern printf('entering discin(%p)\n', file) -> _ ;
+;;;        _extern fflush(_0) -> _ ;
 	if isdevice(file) then
 		file -> dev;
 		Check_device(dev, true)		;;; checks it open
@@ -32,6 +34,8 @@
 		endif;
 		sysopen(file, 0, false, `N`) -> dev
 	endif;
+;;;        _extern printf('discin(%p)\n', file) -> _ ;
+;;;        _extern fflush(_0) -> _ ;
 	Consclos_protect(Io$-Get_char, dev, 1) -> file;
 	device_full_name(dev) -> pdprops(file)
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/errors.p v15.6301-amd64/pop/src/errors.p
--- v15.63/pop/src/errors.p	2004-12-31 07:02:13.000000000 -0500
+++ v15.6301-amd64/pop/src/errors.p	2005-03-11 05:30:39.000000000 -0500
@@ -112,6 +112,8 @@
 
 define Exec_nonpd(item) with_props '(Sys$-Exec_nonpd)';
 	lvars item;
+;;;        _extern printf('Exec_nonpd %p\n', item) -> _;
+;;;        _extern fflush(_0) -> _;
 	mishap(item, 1, 'enp: EXECUTING NON-PROCEDURE')
 enddefine;
 ;;;
@@ -466,6 +468,8 @@
 		pop_message_min_detail -> detail
 	endif;
 
+        5 -> detail;
+
 	if not(_memory_is_corrupt) and severity /== `I`
 	and testdef vedusewindows and weakref vedusewindows then
 		weakref[vedusewindows] wved_mishap_reset()
@@ -509,8 +513,9 @@
 	endif;
 
 	/* PRINT DOING */
-	if detail fi_>= 5
-	and (not(pop_mishap_doing_lim) or pop_mishap_doing_lim fi_> 0) then
+        printf('PRINT DOING\n');
+	if true /* detail fi_>= 5
+	and (not(pop_mishap_doing_lim) or pop_mishap_doing_lim fi_> 0) */ then
 		raise_exception_idstring -> re_idstring;
 		false -> first;
 		0 ->> count -> _nprinted;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/extern_symbols.p v15.6301-amd64/pop/src/extern_symbols.p
--- v15.63/pop/src/extern_symbols.p	2004-12-23 10:42:29.000000000 -0500
+++ v15.6301-amd64/pop/src/extern_symbols.p	2005-03-11 05:30:39.000000000 -0500
@@ -53,11 +53,8 @@
 lconstant macro DLOPEN_FLAGS = 16:005;	;;; RTLD_LAZY|RTLD_GLOBAL
 #_ELSEIF DEF NCR
 lconstant macro DLOPEN_FLAGS = 16:003;	;;; RTLD_LAZY_GLOBAL
-#_ELSEIF DEF OSF1
-;;; Should this be like linux and solaris?? A.S. 23 Dec 2004
+#_ELSEIF DEF OSF1 or DEF LINUX_ELF
 lconstant macro DLOPEN_FLAGS = 16:001;	;;; RTLD_LAZY
-#_ELSEIF DEF LINUX_ELF
-lconstant macro DLOPEN_FLAGS = 16:101;	;;; RTLD_LAZY|RTLD_GLOBAL
 #_ELSEIF DEFV IRIX >= 5.0
 lconstant macro DLOPEN_FLAGS = 16:001;	;;; RTLD_LAZY
 #_ENDIF
@@ -280,11 +277,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, 23 Dec 2004
-		With help from Jeff Best. Changed
-		DLOPEN_FLAGS = 16:101;	;;; RTLD_LAZY|RTLD_GLOBAL
-		for linux as for SunOS, in accordance with comments in
-			/usr/include/bits/dlfcn.h
 --- Robert Duncan, Nov 27 1998
 		Fixed Shlib_findsym to use the proper flags value when calling
 		dlopen()
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/fields.p v15.6301-amd64/pop/src/fields.p
--- v15.63/pop/src/fields.p	2005-01-06 10:13:58.000000000 -0500
+++ v15.6301-amd64/pop/src/fields.p	2009-12-30 21:15:11.000000000 -0500
@@ -282,7 +282,7 @@
 		round_mult(bitoffs,	bitalign) -> bitoffs
 
 	elseif isinteger(spec) and spec /== 0
-	and #_< -INT_BITS >_# fi_<= spec and spec fi_<= INT_BITS then
+	and #_< -WORD_BITS >_# fi_<= spec and spec fi_<= WORD_BITS then
 		if spec fi_< 0 then 0 fi_- spec else spec endif -> bitsize;
 		t_BIT -> type
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/gcmain.p v15.6301-amd64/pop/src/gcmain.p
--- v15.63/pop/src/gcmain.p	1998-06-02 09:14:32.000000000 -0400
+++ v15.6301-amd64/pop/src/gcmain.p	2005-03-11 05:30:39.000000000 -0500
@@ -457,6 +457,8 @@
 					;;; structure follows it
 					_rec@(struct POPREC1)++ -> _rec
 				else
+;;;             _extern printf('_rec!V_LENGTH = 0x%lx\n', _rec!V_LENGTH) -> _ ;
+;;;             _extern fflush(_0) -> _ ;
 					;;; V_LENGTH is a byte length -- get to next word after
 					;;; end of this struct
 					_rec@V_WORDS[_rec!V_LENGTH | b.r]@~POPBASE -> _rec;
@@ -464,6 +466,8 @@
 					;;; next object module)
 					repeat
 						if _rec >=@(w) _lim then
+        _extern printf('RUN OFF at 0x%lx, _rec = 0x%lx\n', _lim, _rec) -> _ ;
+        _extern fflush(_0) -> _ ;
 							mishap(0, 'App_struct_area: RUN OFF END OF AREA')
 						endif;
 						quitif(_rec!KEY == objmod_pad_key);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/getstore.p v15.6301-amd64/pop/src/getstore.p
--- v15.63/pop/src/getstore.p	2003-11-01 16:21:25.000000000 -0500
+++ v15.6301-amd64/pop/src/getstore.p	2005-03-13 05:16:19.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2003. All rights reserved. ----------
+/* --- Copyright University of Sussex 2005. All rights reserved. ----------
  > File:			C.all/src/getstore.p
  > Purpose:
  > Author:			John Gibson (see revisions)
@@ -1024,11 +1024,17 @@
 ;;;
 define updaterof active popmemlim n;
 	lvars n;
+;;;        lconstant _MAX_MEM_MAX = _int(1<<POPINT_BITS - 1);
 	if isbiginteger(n) then
 		if weakref[biginteger_key] Bigint_neg(n) then
 			mishap(n, 1, '(BIG)INTEGER >= 0 NEEDED', ':type-integral-nonneg')
 		else
-			false -> n
+            if n > #_< 1<<POPINT_BITS  - 1 >_# then
+				false -> n
+            else
+               _pint(Pint_->_uint(n,
+                  #_< _int(1<<POPINT_BITS - 1) >_#)) -> n
+            endif
 		endif
 	endif;
 	if n then
@@ -1535,6 +1541,9 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Mar 13 2005
+		Patch to updater of popmemlim provided by Waldek Hebisch
+		for AMD64 poplog
 --- Aaron Sloman, 1 Nov 2003
 	increased default max_mem_lim (popmemlim) from 3e5 tp 15e5
 --- John Gibson, Jun  1 1998
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/initial.p v15.6301-amd64/pop/src/initial.p
--- v15.63/pop/src/initial.p	2009-06-28 23:11:50.000000000 -0400
+++ v15.6301-amd64/pop/src/initial.p	2010-01-03 07:24:11.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2009. All rights reserved. ----------
+/* --- Copyright University of Sussex 2003. All rights reserved. ----------
  > File:            C.all/src/initial.p
  > Purpose:         Global initialisation
  > Author:          John Gibson (see revisions)
@@ -21,9 +21,9 @@
 
 	;;; Internal version number, for allowing library files etc to
 	;;; know about new versions. Used as the version number in the string
-	;;; popversion.
-	;;; (See declaration in declare.ph -- in AIX this is a vars.)
-	156300 -> pop_internal_version;
+	;;; popversion.
+	;;; (See declaration in declare.ph -- in AIX this is a vars.)
+	156301 -> pop_internal_version;
 
 
 	;;; Initialise variables
@@ -44,10 +44,10 @@
 
 
 constant
-	popcopyright = 'Copyright (c) 1982-2009 University of Sussex. All rights reserved.',
+	popcopyright = 'Copyright (c) 1982-1999 University of Sussex. All rights reserved.',
 
 	;;; version number string -- gets concatenated with Sys$-image_date set up
-	;;; by "link" to produce pop_version.
+	;;; by "link" to produce pop_version.
 	Sys$-image_version = '(Version ' >< pop_internal_version/10000.0,
 
 	;;; dummy initialisations
@@ -61,7 +61,7 @@
 	Sys$- _external_flags	= _0,
 	Sys$- _in_X_call		= _0,
 
-	;;; This is non-zero when in user external calls (set by _call_external),
+	;;; This is non-zero when in user external calls (set by _call_external),
 	;;; and enables asynchronous callback by signals.
 	;;; It has the value -1 when completely outside of Pop.
 	Sys$- _in_user_extern	= _-1,
@@ -85,107 +85,84 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Jun 29 2009
-		pop_internal_version = 156300
-		To mark conversion of all documentation to remove special
-		graphics characters.
-		
---- Aaron Sloman, 2 Dec 2008
-		pop_internal_version = 156200
-		For changes by Waldek Hebisch to make use of 'setarch' unnecessary
-		(mainly change in amain.s to invoke linux_setper, defined in
-		$popexternlib/c_core.c)
-		
---- Aaron Sloman, Feb  4 2008
-		pop_internal_version = 156102
-		Only minor changes, including addition of a simple highlighting
-		extension to ved, and improvements to installation scripts
---- Aaron Sloman, Oct  1 2007
-		pop_internal_version = 156101 (various changes, especially unix_dir.p)
---- Aaron Sloman, Apr 11 2007
-		pop_internal_version = 156100 (various changes)
-		
---- Aaron Sloman, Jan 18 2005
-		Chnaged version to
-		pop_internal_version = 156000 (various changes)
 --- Aaron Sloman, 1 Nov 2003
 		Added pop_translate_envvars
 		syfileok will translate environment variables if it is true (default)
 --- John Gibson, Sep 29 1998
-		pop_internal_version = 155210 (various changes)
+		pop_internal_version = 155210 (various changes)
 --- John Gibson, Dec  2 1997
-		pop_internal_version = 155200 (various changes)
+		pop_internal_version = 155200 (various changes)
 --- John Gibson, Apr 30 1997
-		pop_internal_version = 155101 (various changes)
+		pop_internal_version = 155101 (various changes)
 --- John Gibson, Feb 14 1997
-		pop_internal_version = 155100 (16-bit chars)
+		pop_internal_version = 155100 (16-bit chars)
 --- John Gibson, Oct 17 1996
-		pop_internal_version = 155001 (slight change to Popc interface)
+		pop_internal_version = 155001 (slight change to Popc interface)
 --- Robert Duncan, Oct  7 1996
-		pop_internal_version = 155000 (general release)
+		pop_internal_version = 155000 (general release)
 --- John Williams, Sep  6 1996
-		pop_internal_version = 154000 (installing in COGS).
+		pop_internal_version = 154000 (installing in COGS).
 --- John Gibson, Aug 15 1996
-		pop_internal_version = 150301 (external names not translated for Popc)
+		pop_internal_version = 150301 (external names not translated for Popc)
 --- John Williams, May 30 1996
-		pop_internal_version = 150300 (installing in Cogs)
+		pop_internal_version = 150300 (installing in Cogs)
 --- John Gibson, Apr  1 1996
-		pop_internal_version = 150220 (slight change to Popc interface)
+		pop_internal_version = 150220 (slight change to Popc interface)
 --- John Gibson, Mar 26 1996
-		pop_internal_version = 150210 (dlocal allowed at execute level)
+		pop_internal_version = 150210 (dlocal allowed at execute level)
 --- John Gibson, Mar  5 1996
-		Changed default for pop_debugging to true.
+		Changed default for pop_debugging to true.
 --- Robert John Duncan, Jan  8 1996
 		Copyright extended to 1996.
 --- John Williams, Nov 30 1995
-		pop_internal_version = 150200 (no warnings from vars in procedures).
+		pop_internal_version = 150200 (no warnings from vars in procedures).
 		(Note 150100 used by ISL as version number for their re-release
-		 of V15 with the vars change).
+		 of V15 with the vars change).
 --- John Williams, Aug  7 1995
-		pop_internal_version = 150001
+		pop_internal_version = 150001
 --- John Williams, Jul 31 1995
-		pop_internal_version = 150000
+		pop_internal_version = 150000
 --- Robert John Duncan, Jul 12 1995
 		Updated and exported the copyright string.
 --- John Gibson, May 23 1995
-		pop_internal_version = 145300 (new lvars default for procedure formals, etc)
+		pop_internal_version = 145300 (new lvars default for procedure formals, etc)
 --- John Gibson, May 20 1995
-		pop_internal_version = 145200 (first Alpha OSF version)
+		pop_internal_version = 145200 (first Alpha OSF version)
 --- John Gibson, Apr 10 1995
-		pop_internal_version = 145102 (procedure header and key layouts change)
+		pop_internal_version = 145102 (procedure header and key layouts change)
 --- John Williams, Feb  2 1995
-		pop_internal_version = 145101 (fix to I_LBLOCK for Clisp/CLX)
+		pop_internal_version = 145101 (fix to I_LBLOCK for Clisp/CLX)
 --- John Gibson, Dec  8 1994
-		pop_internal_version = 145100 (first Alpha VMS version)
+		pop_internal_version = 145100 (first Alpha VMS version)
 --- John Gibson, Nov 28 1994
 		Moved initialisation of pointer variable pop_external_flags to
 		c_callback.c (pop must refer only to _pop_external_flags)
 --- John Gibson, Oct 24 1994
-		Added new Popc define_extern_name construct for defining
+		Added new Popc define_extern_name construct for defining
 		external names
 --- John Gibson, Jun  2 1994
 		Removed _d*ouble
 --- John Williams, Apr 26 1994
-		Upped pop_internal_version to 145003 after copying 145002
+		Upped pop_internal_version to 145003 after copying 145002
 		as COGS popversion "new".
 --- John Gibson, Feb  7 1994
-		pop_internal_version = 145002 (various Ved changes)
+		pop_internal_version = 145002 (various Ved changes)
 --- Simon Nichols, Nov 29 1993
-		pop_internal_version = 145001 (after copying 14.5)
+		pop_internal_version = 145001 (after copying 14.5)
 --- Simon Nichols, Nov 29 1993
-		pop_internal_version = 145000 (prior to copying 14.5)
+		pop_internal_version = 145000 (prior to copying 14.5)
 --- John Gibson, Aug 16 1993
 		Replaced pop_p*as_mode with internal var vm_pas_mode
 --- John Williams, Jul 13 1993
-		pop_internal_version upped to 142400, just after copying 14.2301
+		pop_internal_version upped to 142400, just after copying 14.2301
 --- John Gibson, May 21 1993
-		Added init for pop_vm_flags
+		Added init for pop_vm_flags
 --- John Gibson, May  2 1993
 		pop_internal_version = 142301 (slight change in POPC interface)
 --- John Williams, Apr 23 1993
 		pop_internal_version upped to 142300, just after copying 14.2201
 --- John Williams, Jan  8 1993
-		pop_internal_version upped to 142201 (new vedsetup_actions)
+		pop_internal_version upped to 142201 (new vedsetup_actions)
 --- John Gibson, Dec 18 1992
 		Moved in initialisations of _external_flags and _in_X_call
 --- John Gibson, Oct 12 1992
Only in v15.63/pop/src: initial.p.2005
Only in v15.63/pop/src: initial.p.2008
Only in v15.63/pop/src: initial.p.2009
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/int_convert.p v15.6301-amd64/pop/src/int_convert.p
--- v15.63/pop/src/int_convert.p	1995-09-19 11:53:14.000000000 -0400
+++ v15.6301-amd64/pop/src/int_convert.p	2009-12-24 15:49:43.000000000 -0500
@@ -36,8 +36,9 @@
 	SAVEWORKBGI(_work, _save1, _save2);
 	BGWEAK Bigint_<< (
 		BGWEAK Pint_to_bigint(
-			_pint( _shift(_n, _negate(_ICVT_SHIFT)) _bimask _ICVT_HIMASK ),
-												_work),
+			_pint( _shift(_n, _negate(_ICVT_SHIFT)) 
+                                  _bimask _ICVT_HIMASK),
+			_work),
 		_ICVT_SHIFT) -> res;
 	RESTWORKBGI(_work, _save1, _save2);
 	_n _bimask _ICVT_LOMASK -> _n;
@@ -79,7 +80,9 @@
 define Pint_->_uint(n, _rangemask);
 	lvars n, _hi, _lo, _rangemask;
 	if isinteger(n) then
-		returnif(_nonneg(_int(n) ->> _hi)) (_hi)
+                _int(n) -> _hi;
+		returnif(_nonneg(_hi) and _hi _lteq _rangemask) (_hi);
+
 	elseif iscompound(n) and n!KEY == weakref biginteger_key then
 		n!BGI_SLICES[_0] _bimask _ICVT_LOMASK -> _lo;
 		BGWEAK Bigint_>>(n, _ICVT_SHIFT) -> _hi;
@@ -89,7 +92,7 @@
 				_shift(_hi, _ICVT_SHIFT) _add _lo -> _hi;
 				returnif(_hi _lteq _rangemask) (_hi)
 			endif
-		endif
+		endif;
 	endif;
 	Err(n, _rangemask, false)
 enddefine;
@@ -97,8 +100,12 @@
 	;;; pop (big)integer -> signed int
 define Pint_->_sint(n, _rangemask);
 	lvars n, _hi, _lo, _mask, _rangemask;
-	returnif(isinteger(n)) (_int(n));
-	if iscompound(n) and n!KEY == weakref biginteger_key then
+        if(isinteger(n)) then
+           _int(n) -> _hi;
+           if _logcom(_rangemask) _slteq _hi and _hi _slteq _rangemask then
+              return (_hi);
+           endif
+	elseif iscompound(n) and n!KEY == weakref biginteger_key then
 		n!BGI_SLICES[_0] _bimask _ICVT_LOMASK -> _lo;
 		BGWEAK Bigint_>>(n, _ICVT_SHIFT) -> _hi;
 		if isinteger(_hi) then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/intvec.p v15.6301-amd64/pop/src/intvec.p
--- v15.63/pop/src/intvec.p	1995-06-03 12:31:03.000000000 -0400
+++ v15.6301-amd64/pop/src/intvec.p	2009-12-30 22:05:52.000000000 -0500
@@ -13,6 +13,19 @@
 
 defclass intvec :int;
 
+defclass untvec :uint;
+
+defclass bytevec :byte;
+
+defclass sbytevec :sbyte;
+
+defclass shortvec :short;
+
+defclass ushortvec :ushort;
+
+defclass longvec :long;
+
+defclass ulongvec :ulong;
 
 /* --- Revision History ---------------------------------------------------
 --- John Gibson, Apr  5 1995
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/io.ph v15.6301-amd64/pop/src/io.ph
--- v15.63/pop/src/io.ph	1997-04-04 08:25:56.000000000 -0500
+++ v15.6301-amd64/pop/src/io.ph	2005-03-11 05:30:39.000000000 -0500
@@ -9,8 +9,8 @@
 #_TERMIN_IF DEF IO_INCLUDED
 
 struct DEVICE
-  { short	D_FLAGS,
-			D_FILE_DESC;
+  { short	D_FLAGS;
+    int		D_FILE_DESC;
 	full	KEY,
 >->			D_CTRL_BLK,
 			D_UNIT_N,
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/itemread.p v15.6301-amd64/pop/src/itemread.p
--- v15.63/pop/src/itemread.p	1996-09-16 10:03:19.000000000 -0400
+++ v15.6301-amd64/pop/src/itemread.p	2005-03-11 05:30:39.000000000 -0500
@@ -123,6 +123,20 @@
 	endif
 enddefine;
 
+constant _print_addr;
+#_IF false
+define nextitem_bb() -> item;
+lvars item;
+    nextitem_true() -> item;
+    _extern printf('_next_code = %ld\nitem:', _next_code)-> _ ;
+    _extern fflush(_0); 
+    _print_addr(item);
+;;; $-Sys$-pretty$-pretty(item);
+    item =>
+    _extern fflush(_0);
+enddefine;
+#_ENDIF
+
 define Chop();
 	unless _next_code == _:M_ID_TERMIN then
 		fast_front(proglist) -> poplastitem;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/lispcore.p v15.6301-amd64/pop/src/lispcore.p
--- v15.63/pop/src/lispcore.p	1998-02-12 09:38:38.000000000 -0500
+++ v15.6301-amd64/pop/src/lispcore.p	2009-12-26 21:58:50.000000000 -0500
@@ -1400,7 +1400,7 @@
 enddefine;
 
 
-define lconstant App_package(pkg, procedure pdr, _do_internals);
+define lconstant App_package(pkg, procedure pdr, _do_internals, check_access);
 	lvars _sl, _offs, _lim, entry;
 	stacklength() -> _sl;
 	pkg!PKG_VECTOR -> pkg;
@@ -1409,7 +1409,10 @@
 	while _offs _lt _lim do
 		pkg!(w){_offs} -> entry;
 		while iscompound(entry) do
-			if _do_internals or (entry!KEY == package_external_entry_key) then
+			if (_do_internals or 
+                             (entry!KEY == package_external_entry_key))
+                           and (not(check_access) 
+                                or check_access(entry!PGE_SYM)) then
 				_CHECKUSER;
 				lisp_apply(Return_symbol(entry!PGE_SYM), pdr, 1, 0)
 			endif;
@@ -1421,15 +1424,21 @@
 
 
 define apppackage(pkg, pdr, do_internals, do_inherits);
-	lvars p;
-	Checkr_package(pkg) -> pkg;
-	$-Sys$-Check_procedure(pdr);
-	App_package(pkg, pdr, pop_true(do_internals));
-	if pop_true(do_inherits) then
-		for p in pkg!PKG_USES do
-			App_package(p, pdr, false)
-		endfor
-	endif
+    lvars p;
+    Checkr_package(pkg) -> pkg;
+    $-Sys$-Check_procedure(pdr);
+    App_package(pkg, pdr, pop_true(do_internals), false);
+    if pop_true(do_inherits) then
+        for p in pkg!PKG_USES do
+            App_package(p, pdr, false,
+                 procedure(sym);
+                     lvars entry, name;
+                     sym!SYM_NAME -> name;
+                     Find_pkg_entry(name, pkg, pkg!PKG_USES) -> (entry, , );
+                     entry and (entry!PGE_SYM == sym);
+                 endprocedure)
+        endfor
+    endif
 enddefine;
 
 
@@ -1551,8 +1560,8 @@
 	endif -> (pkgs, do_inherits);
 
 	fast_for pkg in pkgs do
-		apppackage(
 			pkg,
+		apppackage(
 			procedure(sym);
 				if issubstring(string, symbol_string(sym)) then
 					conspair(sym, list) -> list
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/mknewpop v15.6301-amd64/pop/src/mknewpop
--- v15.63/pop/src/mknewpop	1993-07-14 09:37:02.000000000 -0400
+++ v15.6301-amd64/pop/src/mknewpop	2005-03-11 05:30:39.000000000 -0500
@@ -6,7 +6,12 @@
 # Related Files:    C.vms/src/mknewpop.com, LIB * NEWPOP
 
 IMAGE=$popsys/newpop.psv
+
 corepop11 %nort $popliblib/mkimage.p -entrymain $IMAGE $popliblib/newpop.p
+# cat << EOF > /tmp/mk$$
+# run %nort $popliblib/mkimage.p -entrymain $IMAGE $popliblib/newpop.p
+# EOF
+# gdb -e corepop11 -x /tmp/mk$$
 rm -f $IMAGE-
 
 # --- Revision History ---------------------------------------------------
